{****************************************************************************}
{                                                                            }
{     Fractal Islands V5.0						                                             }
{									                                                                   }
{     Version 1.0 March 5, 1986					                                         }
{     history:  Basic version from Creative Computing, 1985		                }
{     IBM Pascal version, August 1985, Phil Garafolo			                      }
{     Mac Version 1, November 1985, Scott berfield			                        }
{     Windows, menus, etc... added March 5, 1986		                           }
{     Printing added March 11, 1986					                                     }
{     Recompiled under TURBOPascal, 1/16/87 with PICT output added           }
{     Version 4.0 reworked to include on/off toggle for quickdraw color,     }
{     Copy to the clipboard, and scaling levels as well as general cleanup   }
{     10/16/87.								                                                      }
{                                                                            }
{     Multifinder support added 10/22/87                                     }
{****************************************************************************}

PROGRAM fractalsTEST;
{$R-}
{$I-}
{$B+} { Set bundle bit (for icon, etc.) }
{$R Fractals2.Rsrc} { Identify resource file }
{$T APPLFRAC} { Set application ID }
{$U-} { Turn off auto link to runtime units }
{$D+}

  uses PasInOut, Memtypes, QuickDraw, OSIntf, ToolIntf, PackIntf,
    MacPrint,multifndr;

  CONST
    WNETrapnum = $60;
    UnimplTrapNum = $9F;
    ioErrID = 900;
    appleID = 128;
    fileID = 129;
    editID = 130;
    zoomID = 131;
    appleM = 1;
    fileM = 2;
    editM = 3;
    zoomM = 4;
    menuCount = 4;
    NewItem = 1;
    OpenItem = 2;
    SaveItem = 3;
    MacPaintItem = 4;
    PICTItem = 5;
    PrintItem = 6;
    QuitItem = 8;
    windowID = 300;
    undoCommand = 1;
    cutcommand = 3;
    copycommand = 4;
    pastecommand = 5;
    clearcommand = 6;

    OKBtn = OK;
    QUITBtn = 3;
    TextItem = 2;
    jagItem = 8;
    randItem = 10;
    CancelBtn = 4;
    btnOff = 0;
    btnOn = 1;
    HellFreezesOver = FALSE;
    myButtonID = 3001;
    mouse = 2;
    pi = 3.14159;
    Laser = 3;

  TYPE
    diskblock = PACKED ARRAY [1..512] OF qdbyte;

    radbtn =
      RECORD
        number: integer;
        state: integer;
      END;

    radSet =
      RECORD
        rad1: radbtn;
        rad2: radbtn;
      END;

  VAR
    irect, worldrect : rect;
    offscreen, savebits : bitmap;
    offport : grafptr;
    jaggy: integer;
    useColors: boolean;
    swidth, sctop, scright, scleft, scbot: integer;
    OffBits, oldbits: BitMap;
    OffBuffer: PACKED ARRAY [1..72] OF byte;
    dstbuf: diskblock;
    error: boolean;
    lsz, isz, ssz: size;
    BIGNUM, openorprint, nfiles, duh: integer;
    land, sea, sky: pattern;
    state, i: integer;
    myPicture: PicHandle;
    isDrawing, fromdrawing: boolean;
    theButton: integer;
    fileinfo: appfile;
    myWindow: windowptr;
    Wrecord: windowrecord;
    myControl: ControlHandle;
    srect, oldrect: rect;
    myMenus: ARRAY [appleM..zoomM] OF menuhandle;
    dummy: EventRecord;
    seed: longint;
    myDialog: DialogPtr;
    itemHit: integer;
    theType: integer;
    theTextHdl, theOKHdl, itemHdl: handle;
    txtBox, itemBox, OKBox, messageRect: rect;
    randBox, jagBox, radbox: rect;
    theRandHdl, theJagHdl, therad1hdl, theRad2Hdl: handle;
    theText, thejagText, therandText, seedText: str255;
    theCancelHdl: handle;
    ibeamHdl, clockHdl: CursHandle;
    wasDown, isPicture: boolean;
    teHdl: TEHandle;
    a: char;
    pr, done, thatsIt: boolean;
    darray: ARRAY [0..128, 0..64] OF integer;
    ib, mx, my, ax, ay, d, d1, d2, bx, by: integer;
    ex, ey, ds, l, le: integer;
    xx, yy, zz, xt, yt, zt, xe, xp, xo, ye, yp: real;
    ra, rd, rh, r1, vt, sk: real;
    x2, y2, z2, w3, x3, y3, z3, x8, y8: real;
    rads: radset;
    Stp, nope, isWNE: Boolean;
    PrRecordHdl: THPrint;
    PrPortStorage: TPrPort;
    PrintPort: TPPrPort;
    DefaltPage, frme: rect;
    PrDialog: DialogPtr;
    ButRect: rect;
    where: point;
    answer: SFReply;
    WhatHap: OSErr;
    name: STR255;
    refnum: integer;
    VolNum: integer;
    Filenum: integer;
    Precd: TPRINT;
    XSCALE, YSCALE, ZSCALE: real;
    currentitem: longint;

  PROCEDURE doZoom(zoomSize: integer); forward;
  PROCEDURE DoCommand(theCommand: LongInt); forward;

  FUNCTION checkWNE : boolean;
  begin
    checkWNE := NGetTrapAddress(WNETrapnum, ToolTrap) <> NGetTrapAddress(UnimpltrapNum, toolTrap);
  end;
  

  FUNCTION rand: real;

    VAR
      a: real;

    BEGIN
      rand := abs(Random / 32767);
    END;

  FUNCTION pow(x: real; y: real): real;
    BEGIN
      pow := exp(y * ln(x));
    END;

  FUNCTION theFilter(myDialog: dialogPtr; VAR theEvent: EventRecord;
                     VAR item: integer): boolean;

    CONST
      crCode = 13;
      enterCode = 3;

    VAR
      mouseLoc: Point;
      finalTicks: longint;

    BEGIN
      itemHit := 0;
      theFilter := FALSE;

      IF wasDown AND NOT StillDown THEN
        BEGIN
          obscureCursor;
          wasDown := FALSE
        END;

      CASE theEvent.what OF
        nullEvent:
          BEGIN
            GetMouse(mouseLoc);
            IF (ptInRect(mouseLoc, txtBox) OR ptInRect(mouseLoc,
               randBox) OR ptInRect(mouseLoc, jagBox)) THEN
              SetCursor(iBeamHdl^^)
            ELSE SetCursor(arrow);
          END;

        mouseDown:
          BEGIN
            GlobalToLocal(theEvent.where);
            IF (PtInRect(theEvent.where, txtBox) OR ptInRect(theEvent.
               where, randBox) OR ptInRect(theEvent.where, jagBox))
               THEN
              wasDown := true;
            LocalToGlobal(theEvent.where);
          END;

        keyDown:
          BEGIN
            IF (theEvent.message MOD 256) IN [crCode, enterCode] THEN
              BEGIN
                GetDItem(myDialog, OKBtn, theType, theOKHdl, OKBox);
                HiliteControl(ControlHandle(theOKHdl), btnOn);
                Delay(3, finalTicks);
                HiliteControl(ControlHandle(theOKHdl), btnoff);
                theFilter := TRUE;
                itemHit := OKBtn;
              END
          END;
        OTHERWISE
        END
    END; {theFilter}

   PROCEDURE clearit;
    
    VAR
      saveport: grafptr;

    BEGIN
      penpat(sky);
      forecolor(blackcolor);
      backcolor(whitecolor);
      paintrect(worldrect);
    END;

  PROCEDURE PrMessage;

    BEGIN
      PrDialog := GetNewDialog(6001, NIL, pointer( - 1));
      DrawDialog(PrDialog);
    END;

  PROCEDURE ReDrawScreen;

    BEGIN
      copybits(offscreen, myWindow^.portbits, offscreen.bounds, myWindow^.portrect, SrcCopy, nil);
    END;

  PROCEDURE printit;

    VAR
      NumCopies: integer;
      count: integer;
      aPort: GrafPtr;
      status: TPrStatus;

    BEGIN
      propen;
      IF PrStlDialog(PrRecordHdl) THEN
        BEGIN
          IF PrJobDialog(PrRecordHdl) THEN
            BEGIN
              PrMessage;
              GetPort(aPort);
              PrintPort := PrOpenDoc(PrRecordHdl, @PrPortStorage, NIL);
              cliprect(worldRect);
              numCopies := PrRecordHdl^^.PrJob.iCopies;
              FOR count := 1 TO numcopies DO
                BEGIN
                  PrOpenPage(PrintPort, NIL);
                  clearit;
                  drawpicture(myPicture, srect);
                  PrClosePage(printPort);
                END;
              PrCloseDoc(PrintPort);
              IF (prRecordHdl^^.PrJob.bJDocLoop = bSpoolLoop) AND (
                 prError = 0) THEN
                PrPicFile(PrRecordHdl, @prPortStorage, NIL, NIL,
                          status);
              disposDialog(PrDialog);
              SetPort(aPort);
              cliprect(oldrect);
            END; {if}
        END; {if}
      prclose;
    END; {printit}

  PROCEDURE initarrays;

    VAR
      i, j: integer;

    BEGIN
      FOR i := 0 TO 128 DO FOR j := 0 TO 64 DO darray[i, j] := 0;
    END;

  PROCEDURE sorryAlert;

    VAR
      foo: integer;

    BEGIN
      foo := alert(2001, NIL);
    END;

  PROCEDURE DoMenus;

    VAR
      i: integer;

    BEGIN
      myMenus[appleM] := GetMenu(appleID);
      AddResMenu(myMenus[appleM], 'DRVR');
      myMenus[FileM] := GetMenu(fileID);
      myMenus[EditM] := GetMenu(editID);
      myMenus[zoomM] := GetMenu(zoomID);
      FOR i := appleM TO zoomM DO insertMenu(myMenus[i], 0);
      checkitem(mymenus[zoomM], 4, TRUE);
      enableitem(myMenus[editM], 0);
      DrawMenuBar;
    END; {DoMenus}

  PROCEDURE DoWindows;

    BEGIN
      myWindow := GetNewWindow(300, @Wrecord, POINTER( - 1));
      myWindow^.txfont := 0;

    END; {doWindow}

  PROCEDURE setColors(whatisstate: integer);

    BEGIN
      CASE whatisstate OF
        1:
          BEGIN
            IF (Usecolors) THEN
              BEGIN
                land := black;
                sea := black;
                sky := white;
              END
            ELSE
              BEGIN
                land := black;
                sea := ltgray;
                sky := white;
              END;
            textmode(srcxor);
            setport(offport);
            textmode(srcxor);
            setport(myWindow);
          END; {case 1}
        2:
          BEGIN
            IF (usecolors) THEN
              BEGIN
                land := black;
                sea := black;
                sky := black;
              END
            ELSE
              BEGIN
                land := white;
                sea := dkgray;
                sky := black;
              END;
          END; {case 2}
        END; {case}
    END; {setcolors}

  PROCEDURE setupoffscreen;
  const
    scrLeft = 6;
    scrtop = 40;
    scrright = 504;
    scrbottom = 334;
  var
    sizeofmap : size;
    maprowbytes : integer;
    boundary : rect;
  
  begin
    offport := Grafptr(newptr(sizeof(grafport)));
    openport(offport);
    
    maprowbytes := (((scrright - scrleft - 1) div 16) + 1) *2;
    sizeofmap := (scrbottom - scrtop) * maprowbytes;
    setrect(boundary, scrleft, scrtop, scrright, scrbottom);
    offsetrect(boundary, -scrleft, -scrtop);
    with offscreen do
    begin
        baseaddr := QDPtr(newptr(sizeofmap));
        rowbytes := maprowbytes;
        bounds := boundary;
    end;
    
    offport^.portbits := offscreen;
    offport^.portrect := offscreen.bounds;
    setport(offport);
    cliprect(offscreen.bounds);
  end;

  PROCEDURE Initialize;

    VAR
      bigRect: rect;

    BEGIN
      initGraf(@thePort);
      InitFonts;
      FlushEvents(everyEvent, 0);
      InitWindows;
      InitMenus;
      TEInit;
      InitDialogs(NIL);
      InitCursor;
      isWNE := checkWNE;
      PrRecordHdl := THPrint(newHandle(sizeof(precd)));
      PrintDefault(PrRecordHdl);
      iBeamHdl := GetCursor(iBeamCursor);
      hlock(handle(ibeamhdl));
      clockHdl := GetCursor(watchcursor);
      hlock(handle(clockhdl));
      setcursor(clockhdl^^);
      DoMenus;
      DoWindows;
      selectwindow(myWindow);
      SetPort(myWindow);
      scleft := myWindow^.portrect.left;
      scright := myWindow^.portrect.right;
      sctop := myWindow^.portrect.top;
      scbot := myWindow^.portrect.bottom;
      SetRect(sRect, 0, 0, scright, scbot);
      swidth := 512;
      oldrect := sRect;
      setrect(worldrect, 0, 0, 792, 612);
      SetRect(frme, 0, 0, scright - 1, scbot);
      initarrays;
      seed := TickCount;
      RandSeed := seed;
      isPicture := false;
      thatsIt := false;
      le := 5;
      theText := '5';
      seedText := 'R';
      theJagText := '7';
      XSCALE := 7 DIV 10;
      YSCALE := xscale;
      ZSCALE := zscale;
      bignum := 10000;
      lsz := 4;
      isz := 2;
      mypicture := openPicture(sRect);
      closepicture;
      useColors := FALSE;
      checkitem(mymenus[ZoomM], 6, FALSE);
   
      WITH rads DO
        BEGIN
          rad1.number := 11;
          rad1.state := btnOn;
          rad2.number := 12;
          rad2.state := btnOff;
        END;
      state := 1;
      setupoffscreen;
      setcolors(state);
      initcursor;
      error := false;
      currentitem := 4;
      nope := FALSE;
      setrect(irect, 18, 135, 200, 155);
    END; {initialize}

  PROCEDURE AboutFractals;

    VAR
      foo: integer;

    BEGIN
      foo := alert(1001, NIL);
    END;

  PROCEDURE ApplActivate(newEvent: eventRecord);
    
    VAR
      i: integer;

    BEGIN
      FOR i := 1 TO 6 DO
        BEGIN
          disableitem(myMenus[editM], i);
        END;
      enableitem(mymenus[editM], copycommand);
      DrawMenuBar;
    END;

  PROCEDURE ApplDeActivate(newEvent: eventRecord);
    
    VAR
      i: integer;

    BEGIN
      FOR i := 1 TO 6 DO
        BEGIN
          enableitem(myMenus[editM], 0);
          enableitem(myMenus[editM], i);
        END;
      DrawMenuBar;
    END;

  PROCEDURE ApplMouseDown(theWindow: windowPtr; MousePoint: point);

    BEGIN
      thatsit := TRUE;
    END; {applMouseDown}

  PROCEDURE CHeckButton;

    VAR
      tada: boolean;
      event: eventrecord;
      theWind: windowPtr;
      saveport: grafptr;
      saveit : QDHandle;
    BEGIN
      if isWNE then
        tada := waitnextevent(everyevent, event, 0, nil)
      else
        tada := getnextevent(everyevent, event);
      IF event.what = mousedown THEN
        begin
            case FindWindow(Event.where, theWind) of
                incontent : thatsit := TRUE;
                indrag : DragWindow(thewind, event.where, screenbits.bounds);
                inMenuBar: doCommand(menuSelect(Event.where));
                inSysWindow: SystemClick(Event, theWind);
            end;{case}
        end{if}
      else if event.what = updateEvt THEN
        begin
        saveit := myWindow^.picsave;
        myWindow^.picsave := NIL;
        getport(saveport);
        setport(myWindow);
        beginupdate(myWindow);
        redrawscreen;
        endupdate(myWindow);
        setport(saveport);
        myWindow^.picsave := saveit;
        end;
      
    END;

  PROCEDURE getarray;

    BEGIN
      IF ay > my THEN
        BEGIN
          by := mx + 1 - ay;
          bx := mx - ax
        END
      ELSE
        BEGIN
          by := ay;
          bx := ax
        END;
      d := darray[bx, by]
    END;

  PROCEDURE rotate;

    BEGIN
      IF xx <> 0 THEN
        BEGIN
          ra := ArcTan(yy / xx);
          IF xx < 0 THEN ra := ra + pi
        END
      ELSE
        BEGIN
          IF yy <= 0 THEN ra := - pi / 2
          ELSE ra := pi / 2
        END;

      r1 := ra + rh;
      rd := sqrt(xx * xx + yy * yy);
      xx := rd * cos(r1);
      yy := rd * sin(r1)

    END; {rotate}

  PROCEDURE plotline;

    BEGIN
      xp := xp * 0.625;
      yp := 33.14 - 0.663 * yp;
      IF pr THEN
        BEGIN
          x8 := xp;
          y8 := yp;
          xo := xp
        END;

      MoveTo(trunc(x8 + 20), trunc(y8 + 45));
      LineTo(trunc(xp + 20), trunc(yp + 45));
      setport(offport);
      MoveTo(trunc(x8 + 20), trunc(y8 + 45));
      LineTo(trunc(xp + 20), trunc(yp + 45));
      setport(myWindow);
      x8 := xp;
      y8 := yp;

    END; {plotline}

  PROCEDURE tiltdown;

    BEGIN
      rd := sqrt(zz * zz + xx * xx);
      IF xx = 0 THEN ra := pi / 2
      ELSE
        BEGIN
          IF (xx = 0) THEN xx := 0.0001;
          ra := ArcTan(zz / xx);
          IF xx < 0 THEN ra := ra + pi
        END;

      r1 := ra - vt;
      xx := rd * cos(r1) + xx;
      zz := rd * sin(r1)
    END;

  PROCEDURE MovePlot;

    BEGIN
      xx := xx * XSCALE;
      yy := yy * YSCALE;
      zz := zz * ZSCALE;
      rotate;
      tiltdown;

      IF xo = - 999 THEN pr := true
      ELSE pr := false;
      xp := trunc(yy);
      yp := trunc(zz);
      plotline;
    END; {moveplot}

  PROCEDURE sealevel;

    BEGIN

      IF xo <> - 999 THEN
        BEGIN
          IF (z2 > 0) AND (zz > 0) THEN z2 := zz
          ELSE
            BEGIN
              IF (z2 < 0) AND (zz < 0) THEN
                BEGIN
                  z2 := zz;
                  zz := 0
                END
              ELSE
                BEGIN
                  IF ((zz - z2) = 0) THEN zz := zz + 0.0001;
                  w3 := zz / (zz - z2);
                  x3 := (x2 - xx) * w3 + xx;
                  y3 := (y2 - yy) * w3 + yy;
                  z3 := 0;

                  zt := zz;
                  yt := yy;
                  xt := xx;

                  IF zz > 0 THEN
                    BEGIN
                      zz := z3;
                      yy := y3;
                      xx := x3;
                      moveplot;
                      PenPat(land);
                      forecolor(greenColor);
                      setport(offport);
                      PenPat(land);
                      forecolor(greenColor);
                      setport(myWindow);
                      zz := zt;
                      yy := yt;
                      xx := xt;
                      z2 := zz
                    END
                  ELSE
                    BEGIN
                      zz := z3;
                      yy := y3;
                      xx := x3;
                      moveplot;
                      PenPat(sea);
                      IF state = 1 THEN forecolor(blueColor)
                      ELSE forecolor(cyancolor);
                      setport(offport);
                      PenPat(sea);
                      IF state = 1 THEN forecolor(blueColor)
                      ELSE forecolor(cyancolor);
                      setport(myWindow);
                      zz := 0;
                      yy := yt;
                      xx := xt;
                      z2 := zt
                    END;
                END;
            END;
        END
      ELSE
        BEGIN
          IF zz < 0 THEN
            BEGIN
              PenPat(sea);
              IF state = 1 THEN forecolor(blueColor)
              ELSE forecolor(cyancolor);
              setport(offport);
              PenPat(sea);
              IF state = 1 THEN forecolor(blueColor)
              ELSE forecolor(cyancolor);
              setport(myWindow);
              z2 := zz;
              zz := 0
            END
          ELSE
            BEGIN
              PenPat(land);
              forecolor(greencolor);
              setport(offport);
              PenPat(land);
              forecolor(greencolor);
              setport(myWindow);
              z2 := zz
            END;
        END;
      x2 := xx;
      y2 := yy
    END; {sealevel}

  PROCEDURE drawing;

    BEGIN
      getarray;
      zz := d;
      yy := ay / mx * BIGNUM;
      xx := ax / mx * BIGNUM - yy / 2;
      sealevel;
      moveplot
    END;

  PROCEDURE DrawIt;

    VAR
      tempsave: QDHandle;

    BEGIN
      setcolors(state);
      IF isPicture THEN killPicture(myPicture);
      myPicture := openPicture(oldRect);
      clearit;
      setport(offport);
      clearit;
      setport(myWindow);
      isPicture := True;
      ShowPen;
      BEGIN
        ax := 0;
        REPEAT
          xo := - 999;
          ay := 0;
          REPEAT
            drawing;
            ay := ay + 1;
            CheckButton;
          UNTIL ((ay >= ax + 1) OR ThatsIt);
          ax := ax + 1;
        UNTIL ((ax = mx) OR ThatsIt);
      END; {if}

      IF (NOT thatsIt) THEN
        BEGIN
          ay := 0;
          REPEAT
            xo := - 999;
            ax := ay;
            REPEAT
              drawing;
              ax := ax + 1;
              checkbutton;
            UNTIL ((ax = mx) OR ThatsIt);
            ay := ay + 1;
          UNTIL ((ay = mx) OR ThatsIt);
        END; {if}

      IF (NOT thatsIt) THEN
        BEGIN
          ex := 0;
          REPEAT
            xo := - 999;
            ey := 0;
            REPEAT
              ax := ex + ey;
              ay := ey;
              drawing;
              ey := ey + 1;
              CheckButton;
            UNTIL ((ey = (mx - ex)) OR ThatsIt);
            ex := ex + 1;
          UNTIL ((ex = mx) OR ThatsIt);
        END; {if}
      penPat(land);
      pensize(1, 1);

      hidePen;
      closePicture;
      beginupdate(mywindow);
      endupdate(mywindow);
      fromdrawing := true;
    END;

  PROCEDURE putarray;

    BEGIN
      IF ay > my THEN
        BEGIN
          by := mx + 1 - ay;
          bx := mx - ax
        END
      ELSE
        BEGIN
          by := ay;
          bx := ax
        END;
      darray[bx, by] := d
    END;

  PROCEDURE diagheight;

    LABEL
      1000;

    BEGIN
      xe := 0;
      WHILE xe <= (mx - 1) DO
        BEGIN
          ye := ib;
          WHILE ye <= (mx - xe) DO
            BEGIN
              ax := trunc(xe + ye - ib);
              ay := trunc(ye - ib);
              getarray;
              d1 := d;
              ax := trunc(xe + ye + ib);
              ay := trunc(ye + ib);
              getarray;
              d2 := d;
              ax := trunc(xe + ye);
              ay := trunc(ye);
              d := trunc((d1 + d2) / 2 + rand * l / 2 - l / 4);
              putarray;
              ye := ye + sk;
              if (tickcount mod 15 = 0) then
              begin
                invertrect(irect);
                setport(offport);
                invertrect(irect);
                setport(myWindow);
              end;
              checkButton;
              IF (thatsIt) THEN GOTO 1000;
            END;
          xe := xe + sk
        END;
    1000:
    END;

  PROCEDURE yheight;

    LABEL
      2000;

    BEGIN
      xe := mx;
      WHILE xe >= 1 DO
        BEGIN
          ye := ib;
          WHILE ye <= xe DO
            BEGIN
              ax := trunc(xe);
              ay := trunc(ye + ib);
              getarray;
              d1 := d;
              ay := trunc(ye - ib);
              getarray;
              d2 := d;
              d := trunc((d1 + d2) / 2 + rand * l / 2 - l / 4);
              ax := trunc(xe);
              ay := trunc(ye);
              putarray;
              ye := ye + sk;
              if (tickcount mod 15 = 0) then
              begin
                invertrect(irect);
                setport(offport);
                invertrect(irect);
                setport(myWindow);
              end;
              checkButton;
              IF thatsIt THEN GOTO 2000;
            END;
          xe := xe - sk
        END;
    2000:
    END; {yheight}

  PROCEDURE xheight;

    LABEL
      3000;

    BEGIN
      ye := 0;
      WHILE ye <= (mx - 1) DO
        BEGIN
          xe := ib + ye;
          WHILE xe <= mx DO
            BEGIN
              ax := trunc(xe - ib);
              ay := trunc(ye);
              getarray;
              d1 := d;
              ax := trunc(xe + ib);
              getarray;
              d2 := d;
              d := trunc((d1 + d2) / 2 + rand * l / 2 - l / 4);
              ax := trunc(xe);
              ay := trunc(ye);
              putarray;
              xe := xe + sk;
              if (tickcount mod 15 = 0) then
              begin
                invertrect(irect);
                setport(offport);
                invertrect(irect);
                setport(myWindow);
              end;
              checkButton;
              IF thatsIt THEN GOTO 3000;
            END;
          ye := ye + sk
        END;
    3000:
    END;

  PROCEDURE fracture;

    VAR
      n: integer;

    BEGIN
      clearit;
      setport(offport);
      clearit;
      setport(myWindow);
      FlushEvents(EveryEvent, 0);
      ds := 2;
      FOR n := 1 TO le DO ds := trunc(ds + (pow(2, (n - 1))));
      mx := ds - 1;
      my := trunc(mx / 2);
      rh := pi * 30 / 180;
      vt := rh * 1.2;
      moveto(20, 150);
      drawstring('Click button to stop...');
      setport(offport);
      moveto(20, 150);
      drawstring('Click button to stop...');
      setport(myWindow);
      
      FOR n := 1 TO le DO
        BEGIN
          l := trunc(BIGNUM / pow(1.8, n));
          CASE n OF
            1: begin
                MoveTo(20, n * 15);
                DrawString('Fracturing level 1');
                setport(offport);
                MoveTo(20, n * 15);
                DrawString('Fracturing level 1');
                setport(myWindow);
               end;
            2: begin
                MoveTo(20, n * 15);
                DrawString('Fracturing level 2');
                setport(offport);
                MoveTo(20, n * 15);
                DrawString('Fracturing level 2');
                setport(myWindow);
               end;
            3: begin
                MoveTo(20, n * 15);
                DrawString('Fracturing level 3');
                setport(offport);
                MoveTo(20, n * 15);
                DrawString('Fracturing level 3');
                setport(myWindow);
               end;
            4: begin
                MoveTo(20, n * 15);
                DrawString('Fracturing level 4');
                setport(offport);
                MoveTo(20, n * 15);
                DrawString('Fracturing level 4');
                setport(myWindow);
               end;
            5: begin
                MoveTo(20, n * 15);
                DrawString('Fracturing level 5');
                setport(offport);
                MoveTo(20, n * 15);
                DrawString('Fracturing level 5');
                setport(myWindow);
               end;
            6: begin
                MoveTo(20, n * 15);
                DrawString('Fracturing level 6');
                setport(offport);
                MoveTo(20, n * 15);
                DrawString('Fracturing level 6');
                setport(myWindow);
               end;
            7: begin
               MoveTo(20, n * 15);
                DrawString('Fracturing level 7');
                setport(offport);
                MoveTo(20, n * 15);
                DrawString('Fracturing level 7');
                setport(myWindow);
               end;
            END; { case }
          ib := trunc(mx / pow(2, n));
          sk := ib * 2;
          IF (NOT thatsit) THEN xheight;
          IF (NOT thatsit) THEN yheight;
          IF (NOT thatsit) THEN diagheight
        END;
     clearit;
     setport(offport);
     clearit;
     setport(myWindow);
    END;

  PROCEDURE InputDialog;

    LABEL
      9000;

    VAR
      temp, tempJ, tempR, ticks: longint;

    BEGIN
      myDialog := GetNewDialog(128, NIL, pointer( - 1));
      FlushEvents(EveryEvent, 0);

      GetDItem(myDialog, textItem, theType, theTextHdl, txtBox);
      GetDItem(myDialog, jagItem, theType, theJagHdl, JagBox);
      GetDItem(myDialog, randItem, theType, theRandHdl, RandBox);

      SetIText(theTextHdl, theText);
      SetIText(theRandHdl, seedText);
      setItext(theJagHdl, theJagText);

      SetPort(myDialog);
      InitCursor;

      SelIText(myDialog, textItem, 0, 10);
      GetDItem(myDialog, rads.rad1.number, theType, theRad1Hdl, radbox);
      GetDItem(myDialog, rads.rad2.number, theType, theRad2Hdl, radbox);

      CASE rads.rad1.state OF
        btnOn:
          BEGIN
            SetCtlValue(ControlHandle(theRad1Hdl), btnOn);
            rads.rad1.state := btnon;
            SetCtlValue(ControlHandle(theRad2Hdl), btnOff);
            rads.rad2.state := btnoff;
          END;
        btnOff:
          BEGIN
            SetCtlValue(ControlHandle(theRad2Hdl), btnOn);
            rads.rad2.state := btnon;
            SetCtlValue(ControlHandle(theRad1Hdl), btnOff);
            rads.rad1.state := btnoff;
          END;
        END; {case}
      REPEAT
        REPEAT
          modalDialog(@theFilter, itemHit);
          GetDItem(myDialog, itemHit, theType, itemHdl, itemBox);
          IF itemhit IN [rads.rad1.number, rads.rad2.number] THEN
            BEGIN
              WITH rads DO
                BEGIN
                  IF itemhit = rad1.number THEN
                    BEGIN
                      SetCtlValue(ControlHandle(theRad1Hdl), btnOn);
                      rad1.state := btnon;
                      SetCtlValue(ControlHandle(theRad2Hdl), btnOff);
                      rad2.state := btnoff;
                      state := 1;
                    END
                  ELSE IF itemhit = rad2.number THEN
                    BEGIN
                      SetCtlValue(ControlHandle(theRad2Hdl), btnOn);
                      rad2.state := btnon;
                      SetCtlValue(ControlHandle(theRad1Hdl), btnOff);
                      rad1.state := btnoff;
                      state := 2;
                    END;
                END; {with/do}
            END; {if}

        UNTIL ((itemHit = OKBtn) OR (itemHit = QUITBtn) OR (itemHit =
              CancelBtn));

        CASE ItemHit OF
          CancelBtn:
            BEGIN
              nope := true;
              GOTO 9000;
            END;
          QuitBtn:
            BEGIN
              ExitToShell;
            END;
          OKBtn:
            BEGIN
              GetItext(theTextHdl, theText);
              GetIText(theJagHdl, thejagText);
              GetIText(therandHdl, theRandText);
              StringToNum(theText, temp);
              StringToNum(thejagText, tempJ);
              IF ((theRandText <> 'R') AND (theRandText <> 'r')) THEN
                StringToNum(theRandText, tempR)
              ELSE tempR := 0;
            END; {OKBtn}
          END; {case itemHit}
      UNTIL (((temp >= 1) AND (temp <= 7)) AND ((tempJ >= 1) AND (
            tempJ <= 100)) AND ((tempR >= - 32767) AND (tempR <=
            32767)));
      le := temp;
      jaggy := tempj;
      xscale := tempj / 100;
      yscale := xscale;
      zscale := xscale;
      IF ((theRandText <> 'R') AND (theRandText <> 'r')) THEN
        RandSeed := tempR
      ELSE
        BEGIN
          randseed := tickcount MOD 32767;
        END; {else}

      numtostring(Randseed, seedText);
    9000:
      disposDialog(myDialog);
      setport(myWindow);
      initCursor;
    END; {inpuDialog}

  PROCEDURE ErrCheck(resultCode: OSErr);

    LABEL
      5000;

    VAR
      errorString: Str255;

    BEGIN
      CASE resultCode OF
        NoErr, EofErr: GOTO 5000;

        DskFulErr:
          BEGIN
            whathap := FSClose(refnum);
            WITH answer DO whathap := FSDelete(Name, volNum);
            ErrorString := 'Cannot fit any more reports on this disk.'
          END;

        DirFulErr:
          ErrorString := 'Cannot fit any more reports on this disk.';

        IOErr: ErrorString := 'Disk or Drive malfunction.';

        WPrErr: ErrorString := 'The disk is write protected.';

        FLckdErr: ErrorString := 'The file is locked.';

        VLckdErr: ErrorString := 'The volume is locked.';

        VolOffLinErr: ErrorString := 'The volume is off-line.';

        MemFullErr:
          ErrorString := 'Not enough memory for that operation.';

        { Put check for other errors here. }

        OTHERWISE
          NumToString(resultCode, ErrorString)
        END; { case }

      ParamText(ErrorString, '', '', '');
      InitCursor;
      Error := true;
      duh := StopAlert(900, NIL);
    5000:
    END; { ErrCheck }

  PROCEDURE SavePaint;

    LABEL
      6000;

    VAR
      i: integer;
      scanline: integer;
      srcPtr, dstPtr: Ptr;
      dstbytes, header: size;
      oldsrcptr: ptr;
      linerect, offrect, dlinerect: rect;
      theinfo: Finfo;
      THENAME, PTEXT: STR255;

    BEGIN
      
      ptext := 'level';
      THEname := concat(seedtext, ptext);
      THEname := concat(THEname, theText);
      THEname := concat(THEname, '.PAINT');
      setRect(linerect, 0, 0, 499, 1);
      setrect(offrect, 0, 0, 576, 1);
      Dlinerect := linerect;
      offbits.rowbytes := 72;
      offbits.baseaddr := @offbuffer;
      offbits.bounds := offRect;
      oldbits := mywindow^.portbits;
      setportbits(offbits);
      penpat(sky);
      pensize(2, 2);
      moveto(0, 0);
      lineto(576, 0);
      
      pensize(1, 1);
      setportbits(oldbits);

      header := 512;
      setPt(where, 85, 100);
      SFPutFile(where, 'Save paint document as...', THENAME, NIL,
                answer);
      WITH answer DO
        BEGIN
          IF good THEN
            BEGIN
              setcursor(clockhdl^^);
              beginupdate(mywindow);
              redrawscreen;
              endupdate(mywindow);
              name := fname;
              volnum := vRefNum;
              whathap := getfinfo(name, volnum, theInfo);
              IF whathap = FNFErr THEN
                BEGIN
                  whathap := Create(name, Volnum, 'MPNT', 'PNTG');
                  errcheck(whathap);
                  IF error THEN GOTO 6000;
                END
              ELSE
                BEGIN
                  errcheck(whathap);
                  IF error THEN GOTO 6000;
                END;

              whathap := FSOpen(name, volNum, refnum);
              errcheck(whathap);
              IF error THEN GOTO 6000;

              whatHap := setFPos(refnum, fsfromstart, 0);
              errcheck(whathap);
              IF error THEN GOTO 6000;

              FOR i := 1 TO header DO dstbuf[i] := 0;
              WHathap := FSWrite(refnum, header, @dstBuf);
              errcheck(whathap);
              IF error THEN GOTO 6000;

              FOR scanline := 1 TO 296 DO
                BEGIN
                  copybits(mywindow^.portbits, offbits, linerect,
                           Dlinerect, srccopy, NIL);
                  srcPtr := offbits.baseaddr;
                  dstptr := @dstbuf;
                  packbits(srcptr, dstptr, 72);
                  dstbytes := ORD(dstptr) - ORD(@dstBuf);
                  WHatHap := FSWrite(refnum, dstbytes, @dstbuf);
                  errcheck(whathap);
                  IF error THEN GOTO 6000;
                  setRect(linerect, 0, scanline, swidth, scanline + 1);
                END;
              setRect(linerect, 0, 297, swidth, 298);
              copybits(mywindow^.portbits, offbits, linerect,
                       Dlinerect, srccopy, NIL);
              FOR scanline := 297 TO 720 DO
                BEGIN
                  srcptr := offbits.baseaddr;
                  dstptr := @dstbuf;
                  Packbits(srcptr, dstptr, 72);
                  dstbytes := ORD(dstptr) - ORD(@dstBuf);
                  whathap := FSWrite(refnum, dstbytes, @dstbuf);
                  errcheck(whathap);
                  IF error THEN GOTO 6000;
                END;
              whathap := FSClose(refnum);
              errcheck(whathap);
              IF error THEN GOTO 6000;
              whatHap := FlushVol(NIL, volnum);
              errcheck(whathap);
              IF error THEN GOTO 6000;

            END; {if}
        END; {with}
      InitCursor;
    6000:
    END; {SavePaint}

  PROCEDURE SaveIt;

    LABEL
      7000;

    VAR
      pic1Size: size;
      add1: ptr;
      theInfo: fInfo;
      bsz: size;
      THEname, ptext: str255;

    BEGIN
      ptext := 'level';
      THEname := concat(seedtext, ptext);
      THEname := concat(THEname, theText);
      THEname := concat(THEname, '.FRAC');
      bsz := sizeof(boolean);
      setPt(where, 85, 100);
      SFPutFile(where, 'Save fractal as...', THEname, NIL, answer);
      WITH answer DO
        BEGIN
          IF good THEN
            BEGIN
              setcursor(clockhdl^^);
              name := fname;
              volnum := vRefnum;
              whathap := GetFInfo(name, volnum, theInfo);
              IF whathap = FNFErr THEN
                BEGIN
                  whatHap := Create(name, Volnum, 'FRAC', 'ISLE');
                  errcheck(whathap);
                  IF error THEN GOTO 7000;
                END
              ELSE
                BEGIN
                  errcheck(whathap);
                  IF error THEN GOTO 7000;
                END; {if/else}

              whathap := FSOpen(name, volNum, refnum);
              errcheck(whathap);
              IF error THEN GOTO 7000;
              whathap := setfpos(refnum, fsFromStart, 0);
              hlock(handle(mypicture));

              pic1size := gethandleSize(handle(myPicture));

              add1 := pointer(mypicture^);

              stringtonum(seedtext, seed);

              whatHap := FSWrite(refnum, lsz, @pic1size);
              errcheck(whathap);
              IF error THEN GOTO 7000;
              whatHap := FSWrite(refnum, pic1size, add1);
              errcheck(whathap);
              IF error THEN GOTO 7000;

              whatHap := FSWrite(refnum, isz, @state);
              errcheck(whathap);
              IF error THEN GOTO 7000;
              whatHap := FSWrite(refnum, lsz, @seed);
              errcheck(whathap);
              IF error THEN GOTO 7000;
              whatHap := FSWrite(refnum, isz, @LE);
              errcheck(whathap);
              IF error THEN GOTO 7000;
              whatHap := FSWrite(refnum, isz, @jaggy);
              errcheck(whathap);
              IF error THEN GOTO 7000;
              whatHap := FSWrite(refnum, bsz, @USECOLORS);
              errcheck(whathap);
              IF error THEN GOTO 7000;

              whatHap := FSClose(refnum);
              errcheck(whathap);
              IF error THEN GOTO 7000;
              whatHap := FlushVol(NIL, volnum);
              errcheck(whathap);
              IF error THEN GOTO 7000;
              hunlock(handle(mypicture));

            END
          ELSE error := true;
        END;
      initcursor;
    7000:
    END; {saveIt}

  PROCEDURE SavePICT;

    LABEL
      9999;

    VAR
      picSize, header: size;
      add1: ptr;
      theInfo: fInfo;
      THEname, ptext: str255;
      q: INTEGER;

    BEGIN
      ptext := 'level';
      THEname := concat(seedtext, ptext);
      THEname := concat(THEname, theText);
      THEname := concat(THEname, '.PICT');
      header := swidth;
      setPt(where, 85, 100);
      SFPutFile(where, 'Save PICT as...', THENAME, NIL, answer);
      WITH answer DO
        BEGIN
          IF good THEN
            BEGIN
              setcursor(clockhdl^^);
              name := fname;
              volnum := vRefnum;
              whathap := GetFInfo(name, volnum, theInfo);
              IF whathap = FNFErr THEN
                BEGIN
                  whatHap := Create(name, Volnum, 'FRAC', 'PICT');
                  errcheck(whathap);
                  IF error THEN
                    BEGIN
                      GOTO 9999;
                      SYSBEEP(5);
                    END;
                END
              ELSE
                BEGIN
                  errcheck(whathap);
                  IF error THEN
                    BEGIN
                      GOTO 9999;
                      SYSBEEP(5);
                    END;
                END; {if/else}

              whathap := FSOpen(name, volNum, refnum);
              errcheck(whathap);
              IF error THEN
                BEGIN
                  GOTO 9999;
                  SYSBEEP(5);
                END;
              whathap := setfpos(refnum, fsFromStart, 0);
              FOR q := 1 TO header DO dstbuf[q] := 0;
              WHathap := FSWrite(refnum, header, @dstBuf);
              errcheck(whathap);
              IF error THEN
                BEGIN
                  GOTO 9999;
                  SYSBEEP(5);
                END;
              hlock(handle(mypicture));
              picsize := gethandleSize(handle(myPicture));
              add1 := pointer(mypicture^);

              whatHap := FSWrite(refnum, picsize, add1);
              errcheck(whathap);
              IF error THEN
                BEGIN
                  GOTO 9999;
                  SYSBEEP(5);
                END;

              whatHap := FSClose(refnum);
              errcheck(whathap);
              IF error THEN
                BEGIN
                  GOTO 9999;
                  SYSBEEP(5);
                END;
              whatHap := FlushVol(NIL, volnum);
              errcheck(whathap);
              IF error THEN
                BEGIN
                  GOTO 9999;
                  SYSBEEP(5);
                END;
              hunlock(handle(mypicture));

            END
          ELSE error := true;
        END;
      initcursor;
    9999:
    END; {savepict}

  PROCEDURE Readit(name: str255; refnum: integer);

    LABEL
      8000;

    VAR
      num: integer;
      DumSize: size;
      dumadd: ptr;
      i: integer;
      dumstring: str255;
      foobar: longint;
      bsz: size;

    BEGIN
      bsz := sizeof(boolean);
      setcursor(clockhdl^^);

      whathap := FSOpen(name, refnum, fileNum);
      errcheck(whathap);
      IF error THEN GOTO 8000;

      whathap := FSRead(fileNum, lsz, @DumSize);
      errcheck(whathap);
      IF error THEN GOTO 8000;

      sethandleSize(handle(myPicture), dumsize);
      hlock(handle(mypicture));
      dumadd := pointer(mypicture^);
      whatHap := FSRead(fileNum, dumsize, dumadd);
      hunlock(handle(mypicture));
      errcheck(whathap);
      IF error THEN GOTO 8000;

      whathap := FSRead(fileNum, isz, @state);
      errcheck(whathap);
      IF error THEN GOTO 8000;

      whathap := FSRead(fileNum, lsz, @seed);
      errcheck(whathap);
      IF error THEN GOTO 8000;

      whathap := FSRead(fileNum, isz, @le);
      errcheck(whathap);
      IF error THEN GOTO 8000;

      whathap := FSRead(fileNum, isz, @jaggy);
      errcheck(whathap);
      IF error THEN GOTO 8000;

      whathap := FSRead(fileNum, bsz, @USECOLORS);
      errcheck(whathap);
      IF error THEN GOTO 8000;

      whatHap := FSClose(fileNum);
      errcheck(whathap);
      IF error THEN GOTO 8000;

      numToString(seed, seedtext);
      numtostring(le, theText);
      numtostring(jaggy, theJagText);
      CASE state OF
        1:
          BEGIN
            WITH rads DO
              BEGIN
                rad1.state := btnOn;
                rad2.state := btnOff;
              END;
          END;
        2:
          BEGIN
            WITH rads DO
              BEGIN
                rad2.state := btnon;
                rad1.state := btnOff;
              END;
          END;
        END; {case}
      ispicture := true;
      EnableItem(myMenus[fileM], SAVEITEM);
      EnableItem(myMenus[fileM], MACPAINTITEM);
      EnableItem(myMenus[fileM], PICTITEM);
      EnableItem(myMenus[fileM], PRINTITEM);
      FOR i := 1 TO 4 DO
        BEGIN
          EnableItem(myMenus[zoomM], i);
        END;
      setcolors(state);
      if (usecolors) then
        begin

        end
      else
        begin

        end;
      drawmenubar;
      initcursor;
      dozoom(4);
    8000:
    END; {readIt}

  PROCEDURE LoadIt;

    VAR
      theTypeList: SFTypeList;

    BEGIN
      setPt(where, 85, 100);
      theTypeList[0] := 'ISLE';
      SFGetFile(where, '', NIL, 1, theTypeList, NIL, answer);
      WITH answer DO
        BEGIN
          IF good THEN readIt(fName, vRefNum);
        END; {with}

    END; {LoadIt}
    
  procedure dismenus;
  var i : integer;
  begin
  for i := fileM to zoomM do
    begin
    disableitem(myMenus[i],0);
    end;
  end;
  
  procedure enmenus;
  var i : integer;
  begin
  for i := fileM to zoomM do
    begin
    enableitem(myMenus[i],0);
    end;
  end;

  PROCEDURE DoIt;
    
    VAR
      i: integer;

    BEGIN
      InputDialog;
      flushevents(everyevent, 0);
      IF (NOT nope) THEN
        BEGIN
          hiliteMenu(0);
          disMenus;
          SetColors(state);
          initarrays;
          srect := oldrect;
          Fracture;
          DrawIt;
          enMenus;
          EnableItem(myMenus[fileM], SAVEITEM);
          EnableItem(myMenus[fileM], MACPAINTITEM);
          EnableItem(myMenus[fileM], PICTITEM);
          EnableItem(myMenus[fileM], PRINTITEM);
          FOR i := 1 TO 4 DO
            BEGIN
              EnableItem(myMenus[zoomM], i);
            END;
          checkitem(mymenus[zoomM], currentitem, FALSE);
          currentitem := 4;
          checkitem(mymenus[zoomM], currentitem, TRUE);
          drawmenubar;
          isDrawing := False;
        END;
      thatsIt := false;
      nope := false;
      fromdrawing := true;
    END; {doIt}

  PROCEDURE applFile(theItem: integer);

    BEGIN
      CASE theItem OF
        NewItem: doIt;
        OpenItem: LoadIt;
        SaveItem:
          BEGIN
            SaveIt;
            IF error THEN error := false;
          END;
        MACPAINTITEM:
          BEGIN
            SavePaint;
            IF error THEN error := false;
          END;
        PICTItem:
          BEGIN
            SavePICT;
            IF error THEN error := false;
          END;
        PrintItem: PrintIt;
        QuitItem:
          BEGIN
            ExitToShell;
          END;
        END; {case theItem}
    END; {applFile}

  PROCEDURE applEdit(theItem: integer);
    
    VAR
      err: longint;
      picsize: size;

    BEGIN
      err := zeroscrap;
      IF (err <> noerr) THEN sysbeep(5)
      ELSE
        BEGIN
          hlock(handle(mypicture));
          picsize := gethandlesize(handle(mypicture));
          err := putscrap(picsize, 'PICT', ptr(myPicture^));
          hunlock(handle(mypicture));
        END;
      IF (err <> noerr) THEN sysbeep(5);
    END;

  PROCEDURE doZoom;
    
    VAR
      tempW, tempH, tempWmid, tempHmid: real;
      temptext: str255;
      foo: integer;

    BEGIN
      IF (zoomSize = 6) THEN
        BEGIN

          IF (isdrawing = FALSE) AND NOT (Usecolors) THEN
            BEGIN
              sysbeep(5);
              foo := alert(1002, NIL);
            END;
          {set up the colors}
          IF Usecolors THEN
            BEGIN
              checkitem(mymenus[zoomM], 6, FALSE);
              usecolors := FALSE;
            END
          ELSE
            BEGIN
              checkitem(myMenus[zoomM], 6, TRUE);
              usecolors := TRUE;
            END;
        END
      ELSE
        BEGIN
          setcursor(clockhdl^^);
          tempW := oldrect.right - oldrect.left; {480}
          tempH := oldrect.bottom - oldrect.top; {300}
          tempWmid := tempW / 2; {240}
          tempHmid := tempH / 2; {150}
          tempW := tempW * (zoomSize * 0.25); {600}
          tempH := tempH * (zoomSize * 0.25); {187.50}

          srect.left := trunc(tempWMid - (tempW / 2)); {-60}
          srect.right := trunc(tempWMid + (tempW / 2)); {540}
          srect.top := trunc(tempHMid - (tempH / 2)); {56.25}
          srect.bottom := trunc(tempHMid + (tempH / 2)); {243.75}
          
          setport(offport);
          clearit;
          drawpicture(myPicture, sRect);
          setport(myWindow);
          copybits(offscreen, myWindow^.portbits, offscreen.bounds, myWindow^.portrect, srccopy,nil);
          checkitem(mymenus[zoomM], zoomsize, TRUE);
          checkitem(mymenus[zoomM], currentitem, FALSE);
          currentitem := zoomsize;
          setcursor(arrow);
        END;
      penpat(land);
    END;

  PROCEDURE DoCommand;

    VAR
      theMenu, theItem: integer;
      name: str255;
      RefNum: integer;
      dum: integer;

    BEGIN
      theMenu := hiWord(theCommand);
      theItem := loWord(theCommand);
      CASE theMenu OF
        AppleID:
          BEGIN
            IF (theItem = 1) THEN AboutFractals
            ELSE
              BEGIN
                getItem(myMenus[appleM], theItem, name);
                dum := OpenDeskAcc(Name)
              END; {else}
          END; {appleM}

        FileID: ApplFile(theItem);

        EditID: IF NOT systemEdit(theItem - 1) THEN applEdit(theItem);

        ZoomID: DoZoom(theItem);
        END; {case theMenu}
      hiliteMenu(0);
    END; {doCommand}

  PROCEDURE DoKeyDown(Event: EventRecord);

    VAR
      CharCode: char;

    BEGIN
      CharCode := chr(Event.message MOD 256);

      IF BitAnd(Event.modifiers, CmdKey) = CmdKey THEN
        DoCommand(MenuKey(CharCode))
    END; { DoKeyDown }

  PROCEDURE EventLoop;

    VAR
      saveport: GrafPtr;
      GotEvent: boolean;
      NewEvent: EventRecord;
      WhichWindow: WindowPtr;
      Key: char;
      KeyCommand: LongInt;
      WWIII: Boolean;

    BEGIN
      WWIII := False;
      REPEAT
        if isWNE then
            GotEvent := waitnextevent(everyevent, newevent, 0, nil)
        else
            GotEvent := getnextevent(everyevent, newevent);
        IF GotEvent THEN
          BEGIN
            CASE NewEvent.What OF
              mouseDown:
                BEGIN
                  CASE FindWindow(NewEvent.where, whichWindow) OF
                    inMenuBar: doCommand(menuSelect(NewEvent.where));
                    inSysWindow: SystemClick(newEvent, whichWindow);
                    inContent:
                      BEGIN
                        IF whichWindow <> FrontWindow THEN
                          SelectWindow(whichWindow)
                        ELSE applMouseDown(whichWindow, NewEvent.where)
                      END; {case inContent}
                    inGoAway:
                      IF TrackGoAway(whichWindow, NewEvent.Where) THEN
                        BEGIN
                          ExitToShell;
                        END;
                    indrag:
                      DragWindow(whichwindow, newevent.where,
                                 screenbits.bounds);
                    END; {case FWReturnCode}
                END; {case mouseDown}

              KeyDown:
                BEGIN
                  doKeyDown(newEvent);
                END; {Case KeyDown}

              ActivateEvt:
                IF BitAND(NewEvent.modifiers, 1) <> 0 THEN
                  ApplActivate(newEvent)
                ELSE ApplDeActivate(newEvent);

              UpdateEvt:
                BEGIN
                  IF NOT fromDrawing THEN
                    BEGIN
                      setcursor(clockhdl^^);
                      getport(savePort);
                      setPort(myWindow);
                      beginUpdate(WindowPtr(newEvent.message));
                      IF isPicture THEN redrawscreen;
                      endUpdate(windowPtr(newEvent.message));
                      setport(saveport);
                      initcursor;
                    END; {if}
                  fromdrawing := false;
                END;
              OTHERWISE

              END; {NewEvent.What}
          END; {if}
      UNTIL WWIII;
    END; {EventLoop}

  BEGIN
    MoreMasters;
    MoreMasters;
    MoreMasters;
    MoreMasters;
    MoreMasters;
    MoreMasters;
    Initialize;
    CountAppFiles(OpenorPrint, nfiles);
    IF nfiles > 0 THEN
      CASE openorPrint OF
        appopen:
          BEGIN
            getAppFiles(1, fileInfo);
            WITH fileInfo DO Readit(fname, vRefNum);
          END;
        AppPrint:
          BEGIN
            FOR i := 1 TO nfiles DO
              BEGIN
                getAppFiles(i, fileInfo);
                WITH fileinfo DO readit(fname, vrefnum);
                drawpicture(myPicture, sRect);
                printit;
              END;
            exitToShell;
          END;
        END; {case}
    REPEAT
      EventLoop;
    UNTIL HellFreezesOver;
  END. {Fractals2}
