#include <:Mac #includes:asm.h>
#include <:Mac #includes:Color.h>

#include "Commando:Programming:LightspeedC:Vision Lab:shared.h"

pascal int main(AppDataPtr, message)
register SharePtr AppDataPtr;
int message;
{
	OsErr err = noErr;
	switch(message) {
	case initFlags:
		AppDataPtr->theFlags.canRun = TRUE;
		AppDataPtr->theFlags.canBitPlane = TRUE;
		break;
	case doIt:
		err = Threshold(AppDataPtr, message);
		break;
	}
	return(err);
}

int Threshold(AppDataPtr, message)
SharePtr AppDataPtr;
int message;
{
	OsErr err = noErr;
	unsigned long chunkSize;
	register int x, y, value;
	int Xbeg, Ybeg, Xend, Yend;
	/*	set up some local variables */
	Xbeg = AppDataPtr->selRect.left;
	Ybeg = AppDataPtr->selRect.top;
	Xend = AppDataPtr->selRect.right;
	Yend = AppDataPtr->selRect.bottom;
	/*	check image size */
	if ((Xend-Xbeg <= 0) || (Yend-Ybeg <= 0)) {
		/*	return if there is no image to work with */
		return(noErr);
	}
	/*	set up the bar graph so we know about how long our experimental PROC
		needs.  In this case we will use the number of pixels processed.
	*/
	tSizeM  = Xend-Xbeg;
	pSizeM  = 0;
	chunkSize = tSizeM / 16;
	setupBarGraphM("\pThreshold processing");
	/*	finally fill the bits by processing the pixmap */
	for (x = Xbeg; x<Xend; x++) {
		for (y = Ybeg; y<Yend; y++) {
			/*	get the value of the pixel at x, y in the PixMap */
			value = getAPixelM(x, y, AppDataPtr->pixMapPtr);
			/*	turn the value into a gray level from 0 (black) to 255 (white) */
			value = *(AppDataPtr->grayMapPtr+value);
			if (value < 128) {
				/*	set the pixel at x, y in the BitMap if the gray level
					is "dark".
				*/
				if (message == imagePlane) {
					setAPixelM(x-Xbeg, y-Ybeg, AppDataPtr->bitMapPtr, 1);
				}
				else {
					setAPixelM(x, y, AppDataPtr->bitMapPtr, 1);
				}
			}
			else {
				/*	clear the pixel at x, y in the BitMap if the gray level
					is "light".
				*/
				if (message == imagePlane) {
					setAPixelM(x-Xbeg, y-Ybeg, AppDataPtr->bitMapPtr, 0);
				}
				else {
					setAPixelM(x, y, AppDataPtr->bitMapPtr, 0);
				}
			}
		}
		/*	increase the processed bytes counter */
		++pSizeM;
		/*	update the bar graph a total of 16 times */
		if (pSizeM > chunkSize) {
			chunkSize += tSizeM / 16;
			err = updateBarGraphM();
			if (err) {
				break;
			}
		}
	}
	/*	show that we're done */
	updateBarGraphM();
	/*	We finished our job so return with err */
	AppDataPtr->BitsChanged = TRUE;
	/*	REMEMBER to kill the bar graph we put up */
	killBarGraphM();
	return(err);
}
